/***********************************************************************/
/*                                                                     */
/*  FILE        :ProjectSH7267.c                                       */
/*  DATE        :Mon, Aug 16, 2021                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :SH7267                                                */
/*                                                                     */
/*  This file is generated by KPIT GNU Project Generator.              */
/*                                                                     */
/***********************************************************************/
#include    <math.h>
#include    <string.h>
#include    "iodefine.h"

#define ON      0xaa
#define OFF     0

//**********************************************************
//      CC֐                                      
//                      Disable = Int Mask Level 15         
//                      Enable  = Int Mask Level 0          
//**********************************************************
#define disable()   asm("mov.l r0,@-r15");  \
                    asm("stc   sr,r0   ");  \
                    asm("and   #0x0f,r0");  \
                    asm("or    #0xf0,r0");  \
                    asm("ldc   r0,sr   ");  \
                    asm("mov.l @r15+,r0");

#define enable()    asm("mov.l r0,@-r15");  \
                    asm("stc   sr,r0   ");  \
                    asm("and   #0x0f,r0");  \
                    asm("ldc   r0,sr   ");  \
                    asm("mov.l @r15+,r0");

//**********************************************************
//      vg^Cv錾                                    
//**********************************************************
void    Timer0(void);
void    TmStart(short tno,short cnt);

//**********************************************************
//      ϐ錾                                            
//**********************************************************
		UCHAR       *Pointer = {"pointer"};
        UCHAR       TmUp[10];
        UCHAR       TmSt[10];
        USHORT      TmCnt[10];
        float       Fdt;
        double      Ddt;
        long double LDdt;
        ULONG       Bps;
        ULONG       Clk;
        USHORT      Step;
        ULONG       LoopCnt;

//**********************************************************
//      main()                                              
//      PowerON System ClockMode1 
//	            I 48.000x3/2  (72.000MHz)   
//	            B 48.000x3/2  (72.000MHz)   
//	            P 48.000x3/4  (36.000MHz)   
//**********************************************************
void    main(void)
{

    CPG.FRQCR.WORD = 0x0103;        // ClockMode 1
                                    // I 48.000x3  (144.000MHz)
                                    // B 48.000x3/2( 72.000MHz)
                                    // P 48.000x3/4( 36.000MHz)

#if (_RESBANK == 1)
    INTC.IBNR.WORD = 0x4000;        // NMI,UBCȊOoNWgpB
#endif

    //  MTU0 Intialize
    CPG.STBCR3.BIT.MSTP35 = 0;      // Ӽޭٽ޲۰(MTU2)/
    MTU2.TCR_0.BYTE = 0x21;         // TGRA+Pclk/4
	MTU2.TCNT_0.WORD = 0;
	MTU2.TGRA_0.WORD = 9000-1;      // (36.000MHz/4)/9000 = 1000Hz
    MTU2.TMDR_0.BYTE = 0;
    MTU2.TIORH_0.BYTE = 0;
    MTU2.TIORL_0.BYTE = 0;
    MTU2.TIER_0.BIT.TGIEA = 1;      // Interrupt TGIA=EI
    MTU2.TSTR.BIT.CST0 = 1;         // MTU0 Start
    INTC.IPR11.BIT._MTU00 = 14;     // MTU0 IntLevel 14

    //  Debug Port(LED)
	PORT.PECR1.BIT.PE5MD   = 0;		// PE5
	PORT.PEDR0.BIT.PE5DR   = 1;		// High
	PORT.PEIOR0.BIT.PE5IOR = 1;		// OutPut

    TmStart(0,100);                 // 100ms
    LoopCnt = 0;
    Step    = 0;
    Clk = 19660800;
    Bps = 9600;
    Fdt = 9600.0;
   	Ddt = 9600.0;
    LDdt= 9600.0;

    enable();
    while(1)  {
       if (Step == 0) {
            if (TmUp[0] == ON) {
                TmStart(0,100);     // 100ms
          		PORT.PEDR0.BIT.PE5DR ^= 0x1;
            }
       }
        else if (Step == 1) {
            if ((LoopCnt % 100000) == 0) {
          		PORT.PEDR0.BIT.PE5DR ^= 0x1;
            }
        }

        ++LoopCnt;
        ++Clk;
        ++Bps;
        ++Fdt;
        ++Ddt;
        ++LDdt;
    }
}
//**********************************************************
//      Timer0  (1ms)   1000Hz                              
//**********************************************************
void    Timer0(void)
{
    short    i;

    MTU2.TSR_0.BIT.TGFA = 0;

    for(i = 0;i <= 9;i++) {
        if (TmSt[i] == ON) {
            if (--TmCnt[i] == 0) {
                TmUp[i] = ON;
                TmSt[i] = OFF;
            }
        }
    }
}
//**********************************************************
//      TmStart                                             
//**********************************************************
void    TmStart(short tno,short cnt)
{
    TmUp[tno]  = OFF;
    TmCnt[tno] = cnt;
    TmSt[tno]  = ON;
}
//**********************************************************

